(function($){
    $(document).ready(function(){
        getTypes();
        
        $('#carEquipment').change(function(){
            getData();
        });
        
        $('#carModification').change(function(){
            getData();
            getEquipment();
        });
        
        $('#carSerie').change(function(){
            getModification();
        });
        
        $('#carGeneration').change(function(){
            getSerie();
        });
        
        $('#carModel').change(function(){
            getGeneration();
        });
        
        $('#carMark').change(function(){
            getModel();
        });
        
        $('#carType').change(function(){
            getMark();
        });
        
        function getData(){
            var equipment = $('#carEquipment').val();
            var modification = $('#carModification').val();
            $('#carCharValue').html('-');
            $('#carOptionValue').html('-');
            
            var request = $.ajax({
                url: "ajax.php",
                method: "POST",
                data: 'get_params=1&equipment='+equipment+'&modification='+modification,
                dataType: "json"
            });

            request.done(function(data){
                var characteristics = '';
                var options = '';
                
                if(data.characteristic.length){
                    for(var i = 0, max = data.characteristic.length; i < max; i++){
                        var unit = data.characteristic[i].unit ? data.characteristic[i].unit : '';
                        
                        characteristics += '<div class="row">'+
                                                '<div class="col-sm-6">'+data.characteristic[i].name+'</div>'+
                                                '<div class="col-sm-6">'+data.characteristic[i].value+' '+unit+'</div>'+
                                            '</div>';
                    }

                    $('#carCharValue').html(characteristics);
                }
                
                if(data.option.length){
                    for(var i = 0, max = data.option.length; i < max; i++){
                        options += '<div class="row">'+
                                        '<div class="col-sm-6">'+data.option[i].name+'</div>'+
                                        '<div class="col-sm-6">'+data.option[i].value+'</div>'+
                                    '</div>';
                    }

                    $('#carOptionValue').html(options);
                }
            });

            request.fail(function(jqXHR, textStatus){
                alert('Request failed: '+textStatus);
            });
        }
        
        function getEquipment(){
            $('#carEquipment option').not(':first').remove();
            $('#carCharValue').html('-');
            $('#carOptionValue').html('-');
            
            var equipment = $('#carModification').val();
            
            if(equipment == '')
                return false;
            
            var request = $.ajax({
                url: "ajax.php",
                method: "POST",
                data: 'get_equipment='+equipment,
                dataType: "json"
            });

            request.done(function(data){
                var opt = '';
                
                for(var i = 0, max = data.length; i < max; i++){
                    opt += '<option price_min="'+data[i].price_min+'" year="'+data[i].year+'" date_create="'+data[i].date_create+'" date_update="'+data[i].date_update+'" value="'+data[i].id+'">'+data[i].name+'</option>';
                }
                
                $('#carEquipment').append(opt);
            });

            request.fail(function(jqXHR, textStatus){
                alert('Request failed: '+textStatus);
            });
        }
        
        function getModification(){
            $('#carModification option').not(':first').remove();
            $('#carEquipment option').not(':first').remove();
            $('#carCharValue').html('-');
            $('#carOptionValue').html('-');
            
            var modification = $('#carSerie').val();
            
            if(modification == '')
                return false;
            
            var request = $.ajax({
                url: "ajax.php",
                method: "POST",
                data: 'get_modification='+modification,
                dataType: "json"
            });

            request.done(function(data){
                var opt = '';
                
                for(var i = 0, max = data.length; i < max; i++){
                    opt += '<option date_create="'+data[i].date_create+'" date_update="'+data[i].date_update+'" value="'+data[i].id+'">'+data[i].name+'</option>';
                }
                
                $('#carModification').append(opt);
            });

            request.fail(function(jqXHR, textStatus){
                alert('Request failed: '+textStatus);
            });
        }
        
        function getSerie(){
            $('#carSerie option').not(':first').remove();
            $('#carModification option').not(':first').remove();
            $('#carEquipment option').not(':first').remove();
            $('#carCharValue').html('-');
            $('#carOptionValue').html('-');
            
            var serie = $('#carGeneration').val();
            
            if(serie == '')
                return false;
            
            var request = $.ajax({
                url: "ajax.php",
                method: "POST",
                data: 'get_serie='+serie,
                dataType: "json"
            });

            request.done(function(data){
                var opt = '';
                
                for(var i = 0, max = data.length; i < max; i++){
                    opt += '<option date_create="'+data[i].date_create+'" date_update="'+data[i].date_update+'" value="'+data[i].id+'">'+data[i].name+'</option>';
                }
                
                $('#carSerie').append(opt);
            });

            request.fail(function(jqXHR, textStatus){
                alert('Request failed: '+textStatus);
            });
        }
        
        function getGeneration(){
            $('#carGeneration option').not(':first').remove();
            $('#carSerie option').not(':first').remove();
            $('#carModification option').not(':first').remove();
            $('#carEquipment option').not(':first').remove();
            $('#carCharValue').html('-');
            $('#carOptionValue').html('-');
            
            var generation = $('#carModel').val();
            
            if(generation == '')
                return false;
            
            var request = $.ajax({
                url: "ajax.php",
                method: "POST",
                data: 'get_generation='+generation,
                dataType: "json"
            });

            request.done(function(data){
                var opt = '';
                
                for(var i = 0, max = data.length; i < max; i++){
                    opt += '<option year_begin="'+data[i].year_begin+'" year_end="'+data[i].year_end+'" date_create="'+data[i].date_create+'" date_update="'+data[i].date_update+'" value="'+data[i].id+'">'+data[i].name+'</option>';
                }
                
                $('#carGeneration').append(opt);
            });

            request.fail(function(jqXHR, textStatus){
                alert('Request failed: '+textStatus);
            });
        }
        
        function getModel(){
            $('#carModel option').not(':first').remove();
            $('#carGeneration option').not(':first').remove();
            $('#carSerie option').not(':first').remove();
            $('#carModification option').not(':first').remove();
            $('#carEquipment option').not(':first').remove();
            $('#carCharValue').html('-');
            $('#carOptionValue').html('-');
            
            var model = $('#carMark').val();
            
            if(model == '')
                return false;
            
            var request = $.ajax({
                url: "ajax.php",
                method: "POST",
                data: 'get_model='+model,
                dataType: "json"
            });

            request.done(function(data){
                var opt = '';
                
                for(var i = 0, max = data.length; i < max; i++){
                    opt += '<option date_create="'+data[i].date_create+'" date_update="'+data[i].date_update+'" value="'+data[i].id+'">'+data[i].name+'</option>';
                }
                
                $('#carModel').append(opt);
            });

            request.fail(function(jqXHR, textStatus){
                alert('Request failed: '+textStatus);
            });
        }
        
        function getMark(){
            $('#carMark option').not(':first').remove();
            $('#carModel option').not(':first').remove();
            $('#carGeneration option').not(':first').remove();
            $('#carSerie option').not(':first').remove();
            $('#carModification option').not(':first').remove();
            $('#carEquipment option').not(':first').remove();
            $('#carCharValue').html('-');
            $('#carOptionValue').html('-');
            
            var mark = $('#carType').val();
            
            if(mark == '')
                return false;
            
            var request = $.ajax({
                url: "ajax.php",
                method: "POST",
                data: 'get_mark='+mark,
                dataType: "json"
            });

            request.done(function(data){
                var opt = '';
                
                for(var i = 0, max = data.length; i < max; i++){
                    opt += '<option date_create="'+data[i].date_create+'" date_update="'+data[i].date_update+'" value="'+data[i].id+'">'+data[i].name+'</option>';
                }
                
                $('#carMark').append(opt);
            });

            request.fail(function(jqXHR, textStatus){
                alert('Request failed: '+textStatus);
            });
        }
        
        function getTypes(){
            $('#carType option').not(':first').remove();
            $('#carMark option').not(':first').remove();
            $('#carModel option').not(':first').remove();
            $('#carGeneration option').not(':first').remove();
            $('#carSerie option').not(':first').remove();
            $('#carModification option').not(':first').remove();
            $('#carEquipment option').not(':first').remove();
            $('#carCharValue').html('-');
            $('#carOptionValue').html('-');
            
            var request = $.ajax({
                url: "ajax.php",
                method: "POST",
                data: 'get_types=1',
                dataType: "json"
            });

            request.done(function(data){
                var opt = '';
                
                for(var i = 0, max = data.length; i < max; i++){
                    opt += '<option value="'+data[i].id+'">'+data[i].name+'</option>';
                }
                
                $('#carType').append(opt);
            });

            request.fail(function(jqXHR, textStatus){
                alert('Request failed: '+textStatus);
            });
        }
    });
})(jQuery);